// (c) Kristian Laakkonen 2006
// Ohjelmointiputkan lyks ohjelma -kilpailu syyskuu 2006

#include <fstream>
#include <string>
#include <sstream>
#include <vector>
#include <ctime>
#include <cmath>

enum
{
    NUMERO,
    KIRJAIN
};

std::string NumToStr(long int num)
{
    std::stringstream ssNumToStr(std::ios_base::out);
    ssNumToStr << num;
    return ssNumToStr.str();
}

long int StrToNum(std::string str)
{
    std::stringstream ssStrToNum(str);
    long int num;
    ssStrToNum >> num;
    return num;
}

long int CharToNum(char ch)
{
    std::string char_str;
    char_str += ch;
    return StrToNum(char_str);
}

int KirjainVaiNumero(char& ch)
{
    if (ch == '1' || ch == '2'  || ch == '3'  || ch == '4'  || ch == '5'  || ch == '6'  || ch == '7'  || ch == '8'  || ch == '9'  || ch == '0')
      return NUMERO;
    else return KIRJAIN;
}

void EtsiSeuraava(std::string& str, int& pos, int type)
{
    if (type == NUMERO) while (pos < str.length() && KirjainVaiNumero(str[pos]) != NUMERO) pos++;
    else while (pos < str.length() && KirjainVaiNumero(str[pos]) != KIRJAIN) pos++;
}

int main()
{
    std::string valmiit_i_str;
    int valmiit; // kuinka paljon jseni annetaan tiedostossa
    std::string uudet_i_str;
    int uudet; // kuinka paljon jseni ohjelman pit antaa uusina

    std::vector<std::string> valmiit_str_vec; // annetut jsenet taulukossa

    std::string muoto; // jsenen muoto; s = kirjaimia, i = numeroita


    //*** LUETAAN TIEDOSTOSTA "alyhoi.luk" TIEDOT
    std::ifstream alyfile("alyhoi.luk", std::ios::in);
    if (!alyfile) return 1;

    char ch;
    alyfile.get(ch);

    while (KirjainVaiNumero(ch) == NUMERO)
    {
        valmiit_i_str += ch;
        alyfile.get(ch);
    }

    while (ch == ' ') alyfile.get(ch);

    while (KirjainVaiNumero(ch) == NUMERO)
    {
        uudet_i_str += ch;
        alyfile.get(ch);
    }

    valmiit = StrToNum(valmiit_i_str);
    uudet = StrToNum(uudet_i_str);

    char line[21];
    for (int i = 0; i < valmiit; i++)
    {
        alyfile.getline(line, 21);
        valmiit_str_vec.push_back(std::string(line));
    }

    alyfile.close();

    std::vector<std::string> uudet_str_vec(uudet); // uusien jsenten taulukko


    //*** RUVETAAN KSITTELEMN DATAA

    // Katsotaan, mink muotoisia jsenet ovat (ensin kirjaimia vai numeroita, mit sitten...)
    int pos = 0;
    while (pos < valmiit_str_vec.at(0).length())
    {
        if (KirjainVaiNumero(valmiit_str_vec.at(0)[pos]) == NUMERO) muoto += 'i';
        else muoto += 's';
        if (KirjainVaiNumero(valmiit_str_vec.at(0)[pos]) == NUMERO) EtsiSeuraava(valmiit_str_vec.at(0), pos, KIRJAIN);
        else EtsiSeuraava(valmiit_str_vec.at(0), pos, NUMERO);
    }

    // Jos eri jsenet ovat erimuotoisia, hommasta ei tule mitn
    int liianvaikea = 0;
    int vec_pos = 0;
    while (liianvaikea == 0 && vec_pos < valmiit_str_vec.size())
    {
        int tmp_pos = 0;
        std::string muoto2;
        while (tmp_pos < valmiit_str_vec.at(vec_pos).length())
        {
            if (KirjainVaiNumero(valmiit_str_vec.at(vec_pos)[tmp_pos]) == NUMERO) muoto2 += 'i';
            else muoto2 += 's';
            if (KirjainVaiNumero(valmiit_str_vec.at(vec_pos)[tmp_pos]) == NUMERO) EtsiSeuraava(valmiit_str_vec.at(vec_pos), tmp_pos, KIRJAIN);
            else EtsiSeuraava(valmiit_str_vec.at(vec_pos), tmp_pos, NUMERO);
        }

        if (muoto2 != muoto) liianvaikea = 1;
        vec_pos++;
    }

    if (liianvaikea) // luovutetaan, liian vaikea tehtv
    {
        std::ofstream outfile("alyhoi.kir", std::ios::out);
        for (int i = 0; i < uudet; i++) outfile << "00\n";
        outfile.close();

        return EXIT_SUCCESS;
    }

    //*** PLUUPPI UUSIEN JSENTEN TUOTTAMISEEN
    int muoto_pos = 0;
    while (muoto_pos < muoto.length())
    {
        // NAPATAAN ENSIN KSITELTVT PTKT ERIKSEEN KOKO DATASTA
        std::vector<std::string> valmiit_nyk_str_vec(valmiit); // valmiiden jsenten tmnhetkiset tutkittavat osaset

        for (int i = 0; i < valmiit; i++)
        {
            int tmp_alku_pos = 0;
            int tmp_loppu_pos = 0;

            (muoto[muoto_pos] == 'i') ? EtsiSeuraava(valmiit_str_vec.at(i), tmp_alku_pos, NUMERO) : EtsiSeuraava(valmiit_str_vec.at(i), tmp_alku_pos, KIRJAIN);
            for (int j = 0; j < (muoto_pos / 2); j++)
            {
                (muoto[muoto_pos] == 'i') ? EtsiSeuraava(valmiit_str_vec.at(i), tmp_alku_pos, KIRJAIN) : EtsiSeuraava(valmiit_str_vec.at(i), tmp_alku_pos, NUMERO);
                (muoto[muoto_pos] == 'i') ? EtsiSeuraava(valmiit_str_vec.at(i), tmp_alku_pos, NUMERO) : EtsiSeuraava(valmiit_str_vec.at(i), tmp_alku_pos, KIRJAIN);
            }

            tmp_loppu_pos = tmp_alku_pos;
            (muoto[muoto_pos] == 'i') ? EtsiSeuraava(valmiit_str_vec.at(i), tmp_loppu_pos, KIRJAIN) : EtsiSeuraava(valmiit_str_vec.at(i), tmp_loppu_pos, NUMERO);

            valmiit_nyk_str_vec.at(i) = valmiit_str_vec.at(i).substr(tmp_alku_pos, (tmp_loppu_pos - tmp_alku_pos));
        }

        //for (int i = 0; i < valmiit_nyk_str_vec.size(); i++) std::cout << valmiit_nyk_str_vec.at(i) << " ";

        // NUMEROITA
        if (muoto[muoto_pos] == 'i')
        {
            // tarkistetaan, kasvaako jsenten "luku" tasaisesti
            int erotus = StrToNum(valmiit_nyk_str_vec.at(1)) - StrToNum(valmiit_nyk_str_vec.at(0));

            int tasavali = 1; // kasvaako luku tasaisin vlein
            for (int i = 2; i < valmiit_nyk_str_vec.size(); i++)
            {
                if (StrToNum(valmiit_nyk_str_vec.at(i)) - StrToNum(valmiit_nyk_str_vec.at(i - 1)) != erotus) tasavali = 0;
            }

            // jos "luku" kasvaa tasaisesti
            if (tasavali)
            {
                // tuotetaan uusiin jseniin yksi osanen lis
                for (int i = 0; i < uudet_str_vec.size(); i++)
                {
                    uudet_str_vec.at(i) += NumToStr(StrToNum(valmiit_nyk_str_vec.at(valmiit_nyk_str_vec.size() - 1)) + (erotus * (i + 1)));
                }
            }

            // jos "luku" ei kasva tasaisesti
            if (!tasavali)
            {
                // tarkistetaan, kasvaako osasen pituus tasaisesti
                int kasvu = valmiit_nyk_str_vec.at(1).length() - valmiit_nyk_str_vec.at(0).length();

                int tasakasvu = 1; // kasvaako osasen pituus tasaisin vlein
                for (int i = 2; i < valmiit_nyk_str_vec.size(); i++)
                {
                    if (valmiit_nyk_str_vec.at(i).length() - valmiit_nyk_str_vec.at(i - 1).length() != kasvu) tasakasvu = 0;
                }

                // jos osasen pituus kasvaa tasaisesti
                if (tasakasvu)
                {
                    if (kasvu == 0) // kaikki osaset samanpituisia
                    {
                        // "KARTTAMENETELM"
                        int jasenvali = 1;
                        int tasakasvutasavali = 1;
                        
                        int tasakasvu = 1;

                        int moneskojasenryhma = 0;

                        while (jasenvali <= valmiit_nyk_str_vec.size() / 2 && moneskojasenryhma < jasenvali) // jos fiksaat, fiksaa mys if -lauseketta alla
                        {
                            tasakasvu = 1;
                            int tutkittavanum = 0;

                            for (int tutkittavanum = 0; tutkittavanum < valmiit_nyk_str_vec.at(0).length(); tutkittavanum++)
                            {
                                int kasvu = CharToNum(valmiit_nyk_str_vec.at(moneskojasenryhma + jasenvali)[tutkittavanum]) - CharToNum(valmiit_nyk_str_vec.at(moneskojasenryhma)[tutkittavanum]);
                                
                                for (int tutkittavajasen = moneskojasenryhma + jasenvali; tutkittavajasen < valmiit_nyk_str_vec.size(); tutkittavajasen += jasenvali)
                                {
                                    if (CharToNum(valmiit_nyk_str_vec.at(tutkittavajasen)[tutkittavanum]) - CharToNum(valmiit_nyk_str_vec.at(tutkittavajasen - jasenvali)[tutkittavanum]) != kasvu) tasakasvu = 0;
                                }
                            }

                            if (tasakasvu)
                            {
                                moneskojasenryhma++;
                            }

                            if (!tasakasvu)
                            {
                                moneskojasenryhma = 0;
                                jasenvali++;
                            }
                        }
                        
                        if (!tasakasvu || jasenvali > valmiit_nyk_str_vec.size() / 2) tasakasvutasavali = 0; // ei toimannut
                        
                        if (tasakasvutasavali) // "karttamenetelm" toimi
                        {
                        /*
                        moneskojasenryhma
                            moneskonum
                                moneskojasen */
                                
                            for (int jasenryhma = 0; jasenryhma < jasenvali; jasenryhma++)
                            {
                                for (int num = 0; num < valmiit_nyk_str_vec.at(0).length(); num++)
                                {
                                    int jasenaloitus = 0 - (valmiit_nyk_str_vec.size() % jasenvali) + jasenryhma;
                                    if (jasenaloitus < 0) jasenaloitus += jasenvali;
                                    int i, jasen;
                                    for (i = 0, jasen = jasenaloitus /*+ (jasenvali - (valmiit_nyk_str_vec.size() % jasenvali)) - 1*/; jasen < uudet; i++, jasen += jasenvali)
                                    {
                                        // ota viimeinen jsenryhmn jsen ja ota siit ao. numero ja lis siihen mit on listtv
                                        //int viimeisinjasen = (valmiit_nyk_str_vec.size() - 1) - (valmiit_nyk_str_vec.size() % jasenvali) - (abs(jasenryhma - (jasenvali - 1)));

                                        int viimeisinjasen = jasenryhma;
                                        while (viimeisinjasen < valmiit_nyk_str_vec.size()) viimeisinjasen += jasenvali;
                                        viimeisinjasen -= jasenvali;

                                        int kirkasvu = CharToNum(valmiit_nyk_str_vec.at(viimeisinjasen)[num]) - CharToNum(valmiit_nyk_str_vec.at(viimeisinjasen - jasenvali)[num]);
                                        uudet_str_vec.at(jasen) += NumToStr(CharToNum(valmiit_nyk_str_vec.at(viimeisinjasen)[num]) + (kirkasvu * (i + 1)));
                                    }
                                }
                            }
                        }
                        
                        if (!tasakasvutasavali)
                        {
                            // "karttamenetelm" ei toiminut
                        }
                    }
                
                    if (kasvu != 0)
                    {
                        int aloitusosanen = 0; // jos 1. osanen on 1 merkin pitk, siit ei paljoa saa irti, eli:
                        while (aloitusosanen < valmiit_nyk_str_vec.size() && valmiit_nyk_str_vec.at(aloitusosanen).length() < 2) aloitusosanen++; // etsitn vh. 2 merkki pitk osanen

                        // tarkistetaan, kasvaako osasen sisll oleva osanumero tasaisesti saman jsenen sisll
                        int sisakasvu = CharToNum(valmiit_nyk_str_vec.at(aloitusosanen)[1]) - CharToNum(valmiit_nyk_str_vec.at(aloitusosanen)[0]);

                        int tasasisakasvu = 1; // kasvaako osasen sisll oleva numero tasaisesti saman jsenen sisll
                        //luuppi, joka tarkastaa yhden osasen kerrallaan
                        for (int i = 0; i < valmiit_nyk_str_vec.size(); i++)
                        {
                            // siskkinen luuppi, joka tarkastaa osasen sisll yhden numeron kerrallaan
                            for (int j = 1; j < valmiit_nyk_str_vec.at(i).length(); j++)
                            {
                                if (CharToNum(valmiit_nyk_str_vec.at(i)[j]) - CharToNum(valmiit_nyk_str_vec.at(i)[j - 1]) != sisakasvu) tasasisakasvu = 0;
                            }
                        }

                        if (tasasisakasvu)
                        {
                            // tarkistetaan, kasvaako alkunumero tasaisesti
                            int alkunumkasvu = CharToNum(valmiit_nyk_str_vec.at(1)[0]) - CharToNum(valmiit_nyk_str_vec.at(0)[0]);

                            int alkunumtasakasvu = 1; // kasvaako alkunumero tasaisesti
                            for (int i = 2; i < valmiit_nyk_str_vec.size(); i++)
                            {
                                if (CharToNum(valmiit_nyk_str_vec.at(i)[0]) - CharToNum(valmiit_nyk_str_vec.at(i - 1)[0]) != alkunumkasvu) alkunumtasakasvu = 0;
                            }

                            if (alkunumtasakasvu)
                            {
                                // tuotetaan uusiin jseniin yksi osanen lis
                                for (int i = 0; i < uudet_str_vec.size(); i++)
                                {
                                    for (int j = 0; j < valmiit_nyk_str_vec.at(valmiit_nyk_str_vec.size() - 1).length() + (kasvu * (i + 1)); j++)
                                    {
                                        uudet_str_vec.at(i) += NumToStr(CharToNum(valmiit_nyk_str_vec.at(valmiit_nyk_str_vec.size() - 1)[0]) + (sisakasvu * j) + (alkunumkasvu * (i + 1)));
                                    }
                                }
                            }

                            if (!alkunumtasakasvu)
                            {
                                // tarkistetaan, onko edellisen jsenen viimeisen ja seuraavan jsenen ensimmisen numeron erotus sama
                                int valikasvu = CharToNum(valmiit_nyk_str_vec.at(1)[0]) - CharToNum(valmiit_nyk_str_vec.at(0)[valmiit_nyk_str_vec.at(0).length() - 1]);

                                int tasavalikasvu = 1;
                                for (int i = 2; i < valmiit_nyk_str_vec.size(); i++)
                                {
                                    if (CharToNum(valmiit_nyk_str_vec.at(i)[0]) - CharToNum(valmiit_nyk_str_vec.at(i - 1)[valmiit_nyk_str_vec.at(i - 1).length() - 1]) != valikasvu) tasavalikasvu = 0;
                                }

                                // 0, 12, 345, 6789 -tapaus
                                if (tasavalikasvu)
                                {
                                    // tuotetaan uusiin jseniin yksi osanen lis
                                    int viim_viimeinen = CharToNum(valmiit_nyk_str_vec.at(valmiit_nyk_str_vec.size() - 1)[valmiit_nyk_str_vec.at(valmiit_nyk_str_vec.size() - 1).length() - 1]);
                                    for (int i = 0; i < uudet_str_vec.size(); i++)
                                    {
                                        for (int j = 0; j < valmiit_nyk_str_vec.at(valmiit_nyk_str_vec.size() - 1).length() + (kasvu * (i + 1)); j++)
                                        {
                                            uudet_str_vec.at(i) += NumToStr(viim_viimeinen + valikasvu + (sisakasvu * j));
                                            if (j == valmiit_nyk_str_vec.at(valmiit_nyk_str_vec.size() - 1).length() + (kasvu * (i + 1)) - 1) viim_viimeinen += (valikasvu + (sisakasvu * j));
                                        }
                                    }
                                }

                                if (!tasavalikasvu)
                                {
                                    // luovutus
                                }

                            }
                        }
                        
                        if (!tasasisakasvu)
                        {
                            // 10, 100, 1000, 10000 -tapaus?
                        }
                    }
                }

                // jos osasen pituus ei kasva tasaisesti
                if (!tasakasvu)
                {
                    // voiko kyseess olla 9-10 -syndrooma? ( 456, 4567, 45678, 456789, 45678910, ... )
                }
            }
        }

        // KIRJAIMIA
        else
        {
            // tarkistetaan, ovatko kaikki kirjainptkt samanpituisia
            int pituus = valmiit_nyk_str_vec.at(0).length();

            int samanpituiset = 1;
            for (int i = 1; i < valmiit_nyk_str_vec.size(); i++)
            {
                if (valmiit_nyk_str_vec.at(i).length() != pituus) samanpituiset = 0;
            }

            // jos kirjainptkt ovat samanpituisia
            if (samanpituiset)
            {
            /*
                // skrollataan ptkyln jokainen kirjain erikseen
                int kirjain_pos = 0;
                while (kirjain_pos < valmiit_nyk_str_vec.at(0).length())
                {
                    // tarkistetaan, kasvaako kirjain tasaisin vlein
                    char erotus = valmiit_nyk_str_vec.at(1)[kirjain_pos] - valmiit_nyk_str_vec.at(0)[kirjain_pos];

                    int tasavali = 1; // kasvaako kirjain tasaisin vlein
                    for (int i = 2; i < valmiit_nyk_str_vec.size(); i++)
                    {
                        if (valmiit_nyk_str_vec.at(i)[kirjain_pos] - valmiit_nyk_str_vec.at(i - 1)[kirjain_pos] != erotus) tasavali = 0;
                    }

                    if (tasavali)
                    {
                        // tuotetaan uusiin jseniin yksi osanen lis
                        for (int i = 0; i < uudet_str_vec.size(); i++)
                        {
                            uudet_str_vec.at(i) += valmiit_nyk_str_vec.at(valmiit_nyk_str_vec.size() - 1)[kirjain_pos] + (erotus * (i + 1));
                        }
                    }

                    if (!tasavali)
                    {
                        // voehan vimpeli...
                    }

                    kirjain_pos++;
                }
            */

                // "KARTTAMENETELM"
                int jasenvali = 1;
                int tasakasvutasavali = 1;
                
                int tasakasvu = 1;

                int moneskojasenryhma = 0;

                while (jasenvali <= valmiit_nyk_str_vec.size() / 2 && moneskojasenryhma < jasenvali) // jos fiksaat, fiksaa mys if -lauseketta alla
                {
                    tasakasvu = 1;
                    int tutkittavakir = 0;

                    for (int tutkittavakir = 0; tutkittavakir < valmiit_nyk_str_vec.at(0).length(); tutkittavakir++)
                    {
                        char kasvu = valmiit_nyk_str_vec.at(moneskojasenryhma + jasenvali)[tutkittavakir] - valmiit_nyk_str_vec.at(moneskojasenryhma)[tutkittavakir];
                        
                        for (int tutkittavajasen = moneskojasenryhma + jasenvali; tutkittavajasen < valmiit_nyk_str_vec.size(); tutkittavajasen += jasenvali)
                        {
                            if (valmiit_nyk_str_vec.at(tutkittavajasen)[tutkittavakir] - valmiit_nyk_str_vec.at(tutkittavajasen - jasenvali)[tutkittavakir] != kasvu) tasakasvu = 0;
                        }
                    }

                    if (tasakasvu)
                    {
                        moneskojasenryhma++;
                    }

                    if (!tasakasvu)
                    {
                        moneskojasenryhma = 0;
                        jasenvali++;
                    }
                }
                
                if (!tasakasvu || jasenvali > valmiit_nyk_str_vec.size() / 2) tasakasvutasavali = 0; // ei toimannut
                
                if (tasakasvutasavali) // "karttamenetelm" toimi
                {
                /*
                moneskojasenryhma
                    moneskokir
                        moneskojasen */
                        
                    for (int jasenryhma = 0; jasenryhma < jasenvali; jasenryhma++)
                    {
                        for (int kir = 0; kir < valmiit_nyk_str_vec.at(0).length(); kir++)
                        {
                            int jasenaloitus = 0 - (valmiit_nyk_str_vec.size() % jasenvali) + jasenryhma;
                            if (jasenaloitus < 0) jasenaloitus += jasenvali;
                            int i, jasen;
                            for (i = 0, jasen = jasenaloitus /*+ (jasenvali - (valmiit_nyk_str_vec.size() % jasenvali)) - 1*/; jasen < uudet; i++, jasen += jasenvali)
                            {
                                // ota viimeinen jsenryhmn jsen ja ota siit ao. kirjain ja lis siihen mit on listtv
                                //int viimeisinjasen = (valmiit_nyk_str_vec.size() - 1) - (valmiit_nyk_str_vec.size() % jasenvali) - (abs(jasenryhma - (jasenvali - 1)));

                                int viimeisinjasen = jasenryhma;
                                while (viimeisinjasen < valmiit_nyk_str_vec.size()) viimeisinjasen += jasenvali;
                                viimeisinjasen -= jasenvali;

                                char kirkasvu = valmiit_nyk_str_vec.at(viimeisinjasen)[kir] - valmiit_nyk_str_vec.at(viimeisinjasen - jasenvali)[kir];
                                uudet_str_vec.at(jasen) += valmiit_nyk_str_vec.at(viimeisinjasen)[kir] + (kirkasvu * (i + 1));
                            }
                        }
                    }
                }
                
                if (!tasakasvutasavali)
                {
                    // "karttamenetelm" ei toiminut
                }
            }

            // jos kirjainptkt ovat eri pituisia
            if (!samanpituiset)
            {
                {
                    // tarkistetaan, kasvaako osasen pituus tasaisesti
                    int kasvu = valmiit_nyk_str_vec.at(1).length() - valmiit_nyk_str_vec.at(0).length();

                    int tasakasvu = 1; // kasvaako osasen pituus tasaisin vlein
                    for (int i = 2; i < valmiit_nyk_str_vec.size(); i++)
                    {
                        if (valmiit_nyk_str_vec.at(i).length() - valmiit_nyk_str_vec.at(i - 1).length() != kasvu) tasakasvu = 0;
                    }

                    // jos osasen pituus kasvaa tasaisesti
                    if (tasakasvu)
                    {
                        int aloitusosanen = 0; // jos 1. osanen on 1 merkin pitk, siit ei paljoa saa irti, eli:
                        while (aloitusosanen < valmiit_nyk_str_vec.size() && valmiit_nyk_str_vec.at(aloitusosanen).length() < 2) aloitusosanen++; // etsitn vh. 2 merkki pitk osanen

                        // tarkistetaan, kasvaako osasen sisll oleva osakirjain tasaisesti saman jsenen sisll
                        char sisakasvu = valmiit_nyk_str_vec.at(aloitusosanen)[1] - valmiit_nyk_str_vec.at(aloitusosanen)[0];

                        int tasasisakasvu = 1; // kasvaako osasen sisll oleva kirjain tasaisesti saman jsenen sisll
                        //luuppi, joka tarkastaa yhden osasen kerrallaan
                        for (int i = 0; i < valmiit_nyk_str_vec.size(); i++)
                        {
                            // siskkinen luuppi, joka tarkastaa osasen sisll yhden kirjaimen kerrallaan
                            for (int j = 1; j < valmiit_nyk_str_vec.at(i).length(); j++)
                            {
                                if (valmiit_nyk_str_vec.at(i)[j] - valmiit_nyk_str_vec.at(i)[j - 1] != sisakasvu) tasasisakasvu = 0;
                            }
                        }

                        if (tasasisakasvu)
                        {
                            // tarkistetaan, kasvaako alkukirjain tasaisesti
                            char alkukirkasvu = valmiit_nyk_str_vec.at(1)[0] - valmiit_nyk_str_vec.at(0)[0];

                            int alkukirtasakasvu = 1; // kasvaako alkukirjain tasaisesti
                            for (int i = 2; i < valmiit_nyk_str_vec.size(); i++)
                            {
                                if (valmiit_nyk_str_vec.at(i)[0] - valmiit_nyk_str_vec.at(i - 1)[0] != alkukirkasvu) alkukirtasakasvu = 0;
                            }

                            if (alkukirtasakasvu)
                            {
                                // tuotetaan uusiin jseniin yksi osanen lis
                                for (int i = 0; i < uudet_str_vec.size(); i++)
                                {
                                    for (int j = 0; j < valmiit_nyk_str_vec.at(valmiit_nyk_str_vec.size() - 1).length() + (kasvu * (i + 1)); j++)
                                    {
                                        uudet_str_vec.at(i) += valmiit_nyk_str_vec.at(valmiit_nyk_str_vec.size() - 1)[0] + (sisakasvu * j) + (alkukirkasvu * (i + 1));
                                    }
                                }
                            }

                            if (!alkukirtasakasvu)
                            {
                                // tarkistetaan, onko edellisen jsenen viimeisen ja seuraavan jsenen ensimmisen numeron erotus sama
                                char valikasvu = valmiit_nyk_str_vec.at(1)[0] - valmiit_nyk_str_vec.at(0)[valmiit_nyk_str_vec.at(0).length() - 1];

                                int tasavalikasvu = 1;
                                for (int i = 2; i < valmiit_nyk_str_vec.size(); i++)
                                {
                                    if (valmiit_nyk_str_vec.at(i)[0] - valmiit_nyk_str_vec.at(i - 1)[valmiit_nyk_str_vec.at(i - 1).length() - 1] != valikasvu) tasavalikasvu = 0;
                                }

                                // A, BC, DEF, GHIJ -tapaus
                                if (tasavalikasvu)
                                {
                                    // tuotetaan uusiin jseniin yksi osanen lis
                                    char viim_viimeinen = valmiit_nyk_str_vec.at(valmiit_nyk_str_vec.size() - 1)[valmiit_nyk_str_vec.at(valmiit_nyk_str_vec.size() - 1).length() - 1];
                                    for (int i = 0; i < uudet_str_vec.size(); i++)
                                    {
                                        for (int j = 0; j < valmiit_nyk_str_vec.at(valmiit_nyk_str_vec.size() - 1).length() + (kasvu * (i + 1)); j++)
                                        {
                                            uudet_str_vec.at(i) += viim_viimeinen + valikasvu + (sisakasvu * j);
                                            if (j == valmiit_nyk_str_vec.at(valmiit_nyk_str_vec.size() - 1).length() + (kasvu * (i + 1)) - 1) viim_viimeinen += (valikasvu + (sisakasvu * j));
                                        }
                                    }
                                }

                                if (!tasavalikasvu)
                                {
                                    // luovutus
                                }

                            }
                        }

                        if (!tasasisakasvu)
                        {
                            // AB, ABB, ABBB, ABBBB -tapaus? tai IIVV, IIVVII, IIVVIIVV, ...
                            
                            int samamuototoistuu = 1;
                        }
                    }

                    // jos osasen pituus ei kasva tasaisesti
                    if (!tasakasvu)
                    {
                        // hmm...
                    }
                }
            }
        }

        muoto_pos++;
    }
    // PLUUPIN LOPPU

    //*** TULOSTETAAN TIEDOSTOON "alyhoi.kir" TUOTETUT UUDET JSENET
    std::ofstream outfile("alyhoi.kir", std::ios::out);
    for (int i = 0; i < uudet; i++) outfile << uudet_str_vec.at(i) << "\n";
    outfile.close();

    return EXIT_SUCCESS;
}
