#include <iostream>
#include "simplerepeatingsolver.h"
using namespace std;

//-----------------------------------------------------------------------------
// Searches simple repeating patterns e.g.
// A,B,A,B,A
// 1,2,3,1,2,3
bool SimpleRepeatingSolver::Solve()
//-----------------------------------------------------------------------------
    {
    iAnswer.clear();
    int count = iPattern.size();
    int tries = min( count / 2 + 2, count );
    if( iMaxIteration <= 0 )
        return false;

    for( int i = 2; i < tries; i++ )
        {
        if( TrySteps(i) )
            {
            for( int j = 0; j < iRequired; j++ )
                {
                string str( iPattern[ ( count + j ) % i ] );
                iAnswer.push_back( str );
                }
            stringstream str;
            str << "(srep:" << i << "/"<< count << ")";
            iSolverStr = str.str();
            return true;
            }
        }
    return false;
    }

//-----------------------------------------------------------------------------
bool SimpleRepeatingSolver::TrySteps( int aSteps )
//-----------------------------------------------------------------------------
{
    int count = iPattern.size();
    if( aSteps >= count )
        return false;

    for( int j = 0; j < aSteps; j++ )
        {
        int k = j;
        while( k + aSteps < count )
            {
            if( iPattern[k] != iPattern[ k + aSteps ] )
                return false;
            k += aSteps;
            };
        }
    return true;
}
